unit Core_Input;

interface

uses
  Windows,
  DirectInput;

const
  SAMPLE_BUFFER_SIZE = 8;   //  

var
  //    
  Dinput : IDirectInput8;
  DIK : IDirectInputDevice8;
  DIJ : IDirectInputDevice8;

procedure Core_Input_Init(Handle : HWND);  

implementation

//=============================================================================
// DirectInput Init
//=============================================================================
procedure Core_Input_Init(Handle : HWND);
var
  dip : TDIPropDWord;
  diprg : TDIPropRange;
  Ddc : TDIDevCaps;
  hret : HRESULT;
begin
  Dinput:= nil;
  DIK:= nil;

  hret:= DirectInput8Create(HInstance, DIRECTINPUT_VERSION, IID_IDirectInput8, Dinput, nil);
  if hret <> DI_OK then exit;
  hret:=Dinput.CreateDevice(GUID_SysKeyboard, DIK, nil);
  if hret <> DI_OK then exit;
  hret:= DIK.SetDataFormat(c_dfDIKeyboard);
  if hret <> DI_OK then exit;
  hret:= DIK.SetCooperativeLevel(Handle, DISCL_EXCLUSIVE or DISCL_FOREGROUND);
  if hret <> DI_OK then exit;

  ZeroMemory(@dip, SizeOf(dip));
  with dip do
  begin
    diph.dwSize:= SizeOf(Tdipropdword);
    diph.dwHeaderSize:= SizeOf(Tdipropheader);
    diph.dwObj:= 0;
    diph.dwHow:= DIPH_DEVICE;
    dwData:= SAMPLE_BUFFER_SIZE;
  end;

  hret:= DIK.SetProperty(DIPROP_BUFFERSIZE, dip.diph);
  if hret <> DI_OK then exit;
  hret:= DIK.Acquire;
  if hret <> DI_OK then exit;

  // JOY
  DIJ:= nil;

  hret:=Dinput.CreateDevice(GUID_Joystick, DIJ, nil);
  if hret <> DI_OK then exit;
  hret:= DIJ.SetDataFormat(c_dfDIJoystick2);
  if hret <> DI_OK then exit;
  hret:= DIJ.SetCooperativeLevel(Handle, DISCL_EXCLUSIVE or DISCL_FOREGROUND);
  if hret <> DI_OK then exit;

  DIJ.GetCapabilities(Ddc);

  ZeroMemory(@dip, SizeOf(diprg));
  with dip do
  begin
    diprg.diph.dwSize:= SizeOf(Tdipropdword);
    diprg.diph.dwHeaderSize:= SizeOf(Tdipropheader);
    diprg.diph.dwObj:= 0;
    diprg.diph.dwHow:= DIPH_BYID;
    dwData:= SAMPLE_BUFFER_SIZE;
    diprg.lMin:= -1000;
    diprg.lMax:= +1000;
  end;

  DIJ.SetProperty(DIPROP_RANGE, diprg.diph);
  DIJ.Acquire;
  
end;


end.

