//=============================================================================
//
//              Unit  :  SysUtilsEx.Pas
//            Author  :  Darthman
//      Last Changes  :  05.01.2004
//          Purposes  :  This unit can be used instead SysUtils.pas
//                       for smallest executable size
//
//=============================================================================

unit SysUtilsEx;

interface

uses
  Windows;

function IntToStr(const Num : Integer) : String;
function StrToInt(const Str : string) : integer;
function LoWord(input : Cardinal) : word;
function HiWord(input : Cardinal) : Word;
function UpperCase(const S: string): string;

implementation

//=============================================================================
// integer to string conversion
//=============================================================================
function IntToStr(const Num : Integer) : String;
begin
  Str(Num, result);
end;

//=============================================================================
// string to integer conversion
//=============================================================================
function StrToInt(const Str : string) : integer;
var
  code : integer;
begin
  Val(Str, result, code);
end;

//=============================================================================
// low Word
//=============================================================================
function LoWord(input : Cardinal) : word;
begin
  Result:= input and $FFFF;
end;

//=============================================================================
// High Word
//=============================================================================
function HiWord(input : Cardinal) : Word;
begin
  Result:= input shr 16;
end;

//=============================================================================
// UpperCase
//=============================================================================
function UpperCase(const S: string): string;
var
  Ch: Char;
  L: Integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'a') and (Ch <= 'z') then Dec(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;

end.
