//=============================================================================
//  Turrican Game. Written in borland Delphi 7. Develop time - 3 weeks.
//  This game developed for independent game developers contest (http://coderpro.ru)
//
//  Game Based on very small and ugly "Core" Engine.
//  Great thanks to Factor5 and Rainbow Arts for Idea, GFX, Sound and music.
//  Additional thx : Mr.Big, woXes, Spirit-1, Cyborg, for their input and support.
//
//  Author : Darthman (Eliiah Prokhodtscev)
//  Place  : Moscow, Russia
//  Time   : october 2005
//
//  This Game distributed under Mozilla GPL public license. This Game is
//  Opensource and not finished by author on 100%.
//
//  If anyone want to finish that work - contact with me.
//  ICQ : 121-212-716
//  Email : darthman@batteryeater.com
//  Web : http://darthman.com
//
//=============================================================================

Program TGame;

{%ToDo 'TGame.todo'}

uses
  windows,
  messages,
  shellapi,
  DirectDraw in 'Headers\DirectDraw.pas',
  DirectInput in 'Headers\DirectInput.pas',
  DirectSound in 'Headers\DirectSound.pas',
  DXTypes in 'Headers\DXTypes.pas',
  defs in 'defs.pas',
  mainengine in 'mainengine.pas',
  ddutil in 'DDUtil.pas',
  turrican in 'turrican.pas',
  level in 'level.pas',
  SysUtilsEx in 'SysUtilsEx.pas',
  Weaponry in 'Weaponry.pas',
  Core_Sound in 'Core_Sound.pas',
  Core_Graphic in 'Core_Graphic.pas',
  Core_Input in 'Core_Input.pas',
  Aliens in 'Aliens.pas';

const
  WND_TITLE = 'Turrican game by Darthman';
  APP_NAME = 'Turrican';
  CLS_NAME = APP_NAME;

{$R RES.RES}

//=============================================================================
// WndProc Function
//=============================================================================
function WndProc(hWnd: HWND; Msg: UINT;  wParam: WPARAM;  lParam: LPARAM): LRESULT; stdcall;
begin
  case Msg of
    WM_CREATE :
      begin
        logoLevel.load('levels/logo.tl');

        SetTimer(hWnd, TIMER, 30, nil);

        result:= 0;
      end;
    WM_DESTROY :
      begin
        KillTimer(hWnd, TIMER);

        finished:= true;
        result:= 0;
      end;
    WM_TIMER :
      begin
        framer:= framer + 1;
        if framer = 300 then framer:= 0;

        ReadKeyBoard;
        Process;
        render;
      end;
    else
    Result:= DefWindowProc(hWnd, msg, wParam, lParam);
  end;
end;

//=============================================================================
// Main program function
//=============================================================================
Function WinMain(hInstance : HINST; hPrevInstance : HINST;
                 lpCmdLine : PChar; nCmdShow : Integer) : Integer; stdcall;
var
  wndClass : WndClassEx;
  msg : TMsg;
  dwStyle, dwExStyle : DWORD;
  exitcode : Cardinal;
begin
  wndClass.cbSize:= SizeOf(wndClass);
  wndClass.style:= CS_HREDRAW or CS_VREDRAW;
  wndClass.lpfnWndProc:= @WndProc;
  wndClass.cbClsExtra:= 0;
  wndClass.cbWndExtra:= 0;
  wndClass.hInstance:= hInstance;
  wndClass.hIcon:= LoadIcon(0, 'icon');       //    
  wndClass.hIconSm:= LoadIcon(0, 'icon');
  wndClass.hCursor:= LoadCursor(0,IDC_ARROW);
  wndClass.hbrBackground:= GetStockObject(BLACK_BRUSH); //  ,     :)
  wndClass.lpszMenuName:= Nil;
  wndClass.lpszClassName:= CLS_NAME;

  RegisterClassEx(wndClass);

  dwStyle:= WS_POPUP or WS_CLIPSIBLINGS or WS_CLIPCHILDREN or WS_VISIBLE;    //    
  dwExStyle:= 0;

  h_Wnd:= CreateWindowEx(
     dwExStyle,
     CLS_NAME,
     PChar(APP_NAME),
     dwStyle,
     0,
     0,
     400,
     300,
     0,
     0,
     hInstance,
     nil);

     ShowCursor(false);

  if h_Wnd = 0 then finished:= true;
  ShowWindow(h_Wnd, nCmdShow);
  UpdateWindow(h_Wnd);

  Randomize;

  init;             //    

  while (GetMessage(msg, 0, 0, 0)) do
  begin
    TranslateMessage(msg);
    DispatchMessage(msg);

    if finished then                //    finished
    begin
      GetExitCodeProcess(sei.hprocess, exitcode);      //     
      TerminateProcess(sei.hProcess, exitcode);        //    
      exit;                                            //   
    end;
  end;

  Result:= msg.wParam;
end;

begin
  WinMain( hInstance, hPrevInst, CmdLine, CmdShow );
end.
