unit Weaponry;

interface

uses
  Windows, DirectDraw, DDUtil, Core_Graphic, core_sound;

const
  LASER_DAMAGE_1 = 5;
  LASER_DAMAGE_2 = 10;
  LASER_DAMAGE_3 = 15;
  LASER_DAMAGE_4 = 20;
  LASER_DAMAGE_5 = 25;

type
  //   
  Tshoot = packed record
    X, Y : Integer;
    incX : Integer;
    dead : Boolean;
  end;

  //  
  Tweapon = class
    Image : IDirectDrawSurface7;
    Level : Byte;
    Dir : Shortint;
    Xinc, Yinc : Integer;
    LRects : array [0..4] of TRect;
    RRects : array [0..4] of TRect;
    Damage : array [0..4] of Byte;
    FName : PChar;
    Shoots : array of Tshoot;
    ShootCount : integer;
    constructor create;
    Procedure Shoot(sX, sY : Integer; sdir : Shortint);
    Procedure Draw;
  end;

  Tlaser = class(Tweapon)
    constructor create;
    procedure restore;
  end;

implementation

uses defs, mainengine;

//=============================================================================
// 
//=============================================================================
Procedure Tweapon.Shoot(sX, sY : Integer; sdir : Shortint);
begin
  dir:= sdir;

  inc(ShootCount);
  SetLength(Shoots, ShootCount);

  with Shoots[ShootCount-1] do
  begin
    if dir = 1 then X:= sX
               else X:= sX - (LRects[Level].Right - LRects[Level].Left);

    Y:= sY - (LRects[Level].Bottom - LRects[Level].Top) div 2;

    incX:= Xinc * dir;
  end;

  Core_Sound_Play(sShotLaser);
end;

//=============================================================================
//  
//=============================================================================
procedure TWeapon.Draw();
var
 i: integer;
begin
  for i:= 0 to ShootCount-1 do
  with shoots[i] do
  begin
    if dir = -1 then Core_Graphic_DrawSprite(X + Xpos, Y + Ypos, Image, @Lrects[level])
                else Core_Graphic_DrawSprite(X + Xpos, Y + Ypos, Image, @Rrects[level]);

    X:= X + incX;
    Y:= Y + Yinc;
  end;

  if ShootCount = 0 then exit;

  i:= 0;
  repeat
    if (shoots[i].X + Xpos > screenX) or (shoots[i].X + Xpos < -screenX) or (Shoots[i].dead) then
    if i <> ShootCount then
    begin
      ShootCount:= ShootCount-1;
      shoots[ShootCount].X:= shoots[i].X;
      shoots[ShootCount].Y:= shoots[i].Y;
      shoots[ShootCount].incX:= shoots[i].incX;
      SetLength(Shoots, ShootCount);
      dec(i);
    end;
    inc(i);
  until i = ShootCount;
end;

//=============================================================================
// 
//=============================================================================
constructor Tweapon.create;
begin
  inherited create;
end;

//=============================================================================
//  , ,  
//=============================================================================
constructor TLaser.create;
begin
  inherited create;

  FName:= 'data/Laser.bmp';
  Image:= DDLoadBitmap(DD, FName, 0, 0);
  DDSetColorKey(Image, $FF00FF);

  SetRect(RRects[0], 0, 0, 47, 7);
  SetRect(RRects[1], 0, 8, 47, 27);
  SetRect(RRects[2], 0, 28, 47, 55);
  SetRect(RRects[3], 0, 56, 39, 89);
  SetRect(RRects[4], 0, 90, 47, 129);

  SetRect(LRects[0], 0, 0, 47, 7);
  SetRect(LRects[1], 48, 8, 95, 27);
  SetRect(LRects[2], 48, 28, 95, 55);
  SetRect(LRects[3], 56, 56, 95, 89);
  SetRect(LRects[4], 48, 90, 95, 129);

  Damage[0]:= LASER_DAMAGE_1;
  Damage[1]:= LASER_DAMAGE_2;
  Damage[2]:= LASER_DAMAGE_3;
  Damage[3]:= LASER_DAMAGE_4;
  Damage[4]:= LASER_DAMAGE_5;

  Xinc:= 24;

  Level:= 0;
end;

//=============================================================================
// .  .
//=============================================================================
procedure TLaser.restore;
begin
  DDReLoadBitmap(Image, FName);
  Image._Restore;
end;

end.
