unit mainengine;

interface

uses
  windows,
  defs,
  DirectDraw,
  DDUtil,
  turrican,
  DirectInput,
  DirectSound,
  mmsystem,
  SysUtilsEx,
  weaponry,
  Core_Sound,
  Core_Graphic,
  Core_Input,
  shellapi;

procedure StartMusic(name: string);
procedure EndMusic();
procedure Process();  
procedure Render();
procedure Init();
function RestoreAll : HRESULT;
procedure ReadKeyBoard;
function Collide(var floor: Boolean; var X, Y : integer; movex, movey : Integer) : boolean;
procedure CubesOpen();
procedure CubesClose();

var
  sei : SHELLEXECUTEINFO;              //     

implementation

uses level;

procedure StartMusic(name: string);
begin
  with sei do
  begin
    cbSize:= sizeOf(SHELLEXECUTEINFO);
    fMask:= SEE_MASK_NOCLOSEPROCESS;
    Wnd:= h_Wnd;
    lpVerb:= 'open';
    lpFile:= 'music\tfmxplay.exe';
    lpParameters:= pchar('music\' + name);
    lpDirectory:= '';
    nShow:= SW_SHOWNOACTIVATE;
  end;

  ShellExecuteEx(@sei);
end;

procedure EndMusic();
var
  exitcode : Cardinal;
begin
  GetExitCodeProcess(sei.hprocess, exitcode);      //     
  TerminateProcess(sei.hProcess, exitcode);        //    
end;



//=============================================================================
//   
//=============================================================================
procedure Init();
var
  i: integer;
begin
  // DirectDraw
  Core_Graphic_Init(h_Wnd);

  //  
  Core_Graphic_LoadImage('data/coderpro.bmp', coderpro, $FF00FF);
  Core_Graphic_LoadImage('data/logo.bmp', logo, $FF00FF);
  Core_Graphic_LoadImage('data/star.bmp', star, $FF00FF);
  Core_Graphic_LoadImage('data/font.bmp', font, $000000);
  Core_Graphic_LoadImage('data/digits.bmp', digits, $FF00FF);
  Core_Graphic_LoadImage('data/tiles.bmp', Tiles, $FF00FF);
  Core_Graphic_LoadImage('data/bar.bmp', Bar, $FF00FF);
  Core_Graphic_LoadImage('data/lives.bmp', lives, $FF00FF);
  Core_Graphic_LoadImage('data/score.bmp', score, $FF00FF);
  Core_Graphic_LoadImage('data/crystal.bmp', crystal, $FF00FF);
  Core_Graphic_LoadImage('data/cubes.bmp', Cubes, $FF00FF);
  Core_Graphic_LoadImage('data/bonusflyer.bmp', bonusflyer, $FF00FF);
  Core_Graphic_LoadImage('data/drone_bomb.bmp', dronebomb, $FF00FF);
  Core_Graphic_LoadImage('data/powerup.bmp', Bonuses, $FF00FF);
  Core_Graphic_LoadImage('data/boss.bmp', BOSS, $FF00FF);

  Core_Graphic_InitBackBuffer;

  Core_Graphic_InitGamma;

  // DirectInput
  Core_Input_Init(h_Wnd);

  // DirectSound
  Core_Sound_Init(h_Wnd);

  Core_Sound_LoadWave('sound\LevelDone.wav', sLevelDone);
  Core_Sound_LoadWave('sound\Vorhang.wav', sVorhang);
  Core_Sound_LoadWave('sound\T_shot_laser.wav', sShotLaser);
  Core_Sound_LoadWave('sound\T_arrive.wav', sArrive);
  Core_Sound_LoadWave('sound\extra_diamant.wav', sDiamond);
  Core_Sound_LoadWave('sound\extra_live.wav', sExtraLive);
  Core_Sound_LoadWave('sound\T_fall_landing.wav', sLanding);
  Core_Sound_LoadWave('sound\explo_short.wav', sExplosion);
  Core_Sound_LoadWave('sound\T_hit.wav', sHit);
  Core_Sound_LoadWave('sound\extra_energy.wav', sEnergy);
  Core_Sound_LoadWave('sound\extra_laser.wav', sLaser);
  Core_Sound_LoadWave('sound\explo_normal.wav', sExplosion2);

  // game
  for i:=0 to 4 do
  begin
    stars[i].Frame:= random(12);
    stars[i].X:= random(320);
    stars[i].Y:= random(80);
  end;

  Level1.load('levels/level1.tl');
  EnemyEngine.Init(Level1);

  player:= TTurrican.create(Level1.RespawnX, Level1.RespawnY);
  player.loadsprites;

  weapon_laser:= tlaser.create;
  player.Weapon:= weapon_laser;

  FadeI:= true;
  StartMusic('mdat.T2_Title');
end;

//=============================================================================
//       
//=============================================================================
procedure DrawString(st : String; X, Y : Integer);
var
  i : Integer;
  r : TRect;
  fx, fy : Integer;
  temp : String;
begin
  temp:= UpperCase(st);
  for i:=1 to length(st) do
  begin
    fx:= ((ord(temp[i]) - 32) mod 16)*8;
    fy:= ((ord(temp[i]) - 32) div 16)*8;
    SetRect(r, fx, fy, fx+8, fy+8);
    Core_Graphic_DrawSprite(X + i*8 - 8, Y, font, @r);
  end;
end;

//=============================================================================
//  .  ,  
//=============================================================================
procedure DrawDigits(st : integer; X, Y, No : Integer);
var
  i : Integer;
  r : TRect;
  fx : Integer;
  s : Integer;
begin
  s:= st;
  for i:=1 to No do
  begin
    fx:= (s mod 10)*8;
    SetRect(r, fx, 0, fx+8, 12);
    Core_Graphic_DrawSprite(X + (No - i)*8, Y, digits, @r);
    s:= s div 10;
  end;
end;

//=============================================================================
// 
//=============================================================================
procedure aft1();
begin
  inc(levelNo);
  Level1.clear;
  Level1.load('levels\level' + inttostr(levelNo) + '.tl');
  EnemyEngine.Init(Level1);
  player.Respawn(Level1.RespawnX, Level1.RespawnY);
  StartMusic('mdat.world_1');
end;


//=============================================================================
//   
//=============================================================================
procedure Process();
var
  i, j : Integer;
  rect : TRect;
  rect2, res : TRect;
begin
  if pause > 0 then
  begin
    framer:= 0;
    dec(pause);
    Exit;
  end;

  if pause = 0 then
  begin
    afterpause;
    pause:= -1;
  end;

  if (sMode = smCoder) and (framer = 186) then
  FadeO:= true;

  if (sMode = smCoder) and (framer = 250) then
  begin
    sMode:= smLogo;
    FadeI:= true;
  end;

  if sMode = smLogo then
  begin
    if LMode = lmmove then logoy:= logoy - 2;
    if logoy <= 8 then
    begin
      LMode:= lmStay;
    end;
    if (LMode = lmfade) and (FadeI = false) then LMode:= lmMove;

    //    .   
    if framer mod 2 = 0 then
    for i:=0 to 4 do
    if stars[i].Frame = 12 then
    with stars[i] do begin
      j:= random(high(starsrespawn)*10+10) div 10;
      Frame:= 0;
      X:= starsrespawn[j, 0] - 8;
      Y:= starsrespawn[j, 1];
    end else
    stars[i].Frame:= stars[i].Frame + 1;
  end;

  if sMode = smGame then
  if GMode = gmGame then
  begin
    EnemyEngine.Process(Xpos, Ypos);

    player.process;

    SetRect(rect, player.X, player.Y, player.X + TURR_WIDTH, player.Y + TURR_HEIGHT);

    EnemyEngine.CollideWithPlayer(rect);
    EnemyEngine.CollideWithShoots(player.Weapon);

    // crystalls
    i:= 0;
    if Level1.CrystalsCount > 0 then
    repeat
      SetRect(rect2, Level1.crystals[i].X, Level1.crystals[i].Y, Level1.crystals[i].X + 16, Level1.crystals[i].Y + 16);
      if IntersectRect(res, rect, rect2) then
      begin
        Level1.DeleteCrystal(i);
        player.collect;
        dec(i);
      end;
      inc(i);
    until i = (Level1.CrystalsCount);
    // triggers
    for i:= 0 to Level1.TriggerCount-1 do
    if (IntersectRect(res, rect, level1.triggersrect[i])) then
    begin
      if (Level1.Triggers[i].Trigger = TRIGGER_DEATH) then
      player.Death;

      if (Level1.Triggers[i].Trigger = TRIGGER_ENDLEVEL) then
      begin
        Core_Sound_Play(sLevelDone);      
        EndMusic;
        pause:= 60;
        afterpause:= aft1;
      end;
    end;
  end;

  // CUBES close
  if (SMode = smGame) and (GMode = gmCubesClose) then
  begin
    for i:=0 to 3 do
    begin
      if Xubes[i].X = 127 then continue;

      if (CubesArray[Xubes[i].X + Xubes[i].Xinc, Xubes[i].Y + Xubes[i].Yinc] <> 255) or
         (Xubes[i].X + Xubes[i].Xinc < 0) or
         (Xubes[i].X + Xubes[i].Xinc > 19) or
         (Xubes[i].Y + Xubes[i].Yinc < 0) or
         (Xubes[i].Y + Xubes[i].Yinc > 13) then
      begin
        Xubes[i].Xinc:= 0;
        Xubes[i].Yinc:= 0;
        if ((Xubes[i].X - 1) >= 0) and (CubesArray[Xubes[i].X-1, Xubes[i].Y] = 255) then Xubes[i].Xinc:= -1 else
        if ((Xubes[i].X + 1) <= 19) and (CubesArray[Xubes[i].X+1, Xubes[i].Y] = 255) then Xubes[i].Xinc:= 1 else
        if ((Xubes[i].Y - 1) >= 0) and (CubesArray[Xubes[i].X, Xubes[i].Y-1] = 255) then Xubes[i].Yinc:= -1 else
        if ((Xubes[i].Y + 1) <= 13) and (CubesArray[Xubes[i].X, Xubes[i].Y+1] = 255) then Xubes[i].Yinc:= 1 else
        Xubes[i].X:= 127;
      end;
      Xubes[i].X:= Xubes[i].X + Xubes[i].Xinc;
      Xubes[i].Y:= Xubes[i].Y + Xubes[i].Yinc;
      CubesArray[Xubes[i].X, Xubes[i].Y]:= 0;
    end;

    for i:= 0 to 19 do
    for j:= 0 to 13 do
    if (CubesArray[i, j] < 8) then CubesArray[i, j]:= CubesArray[i, j] + 1;

    sVorhang.Play(0, 0, 0);

    If framer >= 75 then
    begin
      GMode:= gmGame;
      Core_Sound_Play(sArrive);
    end;
  end;

  // CUBES open
  if (SMode = smGame) and (GMode = gmCubesOpen) then
  begin
    for i:=0 to 3 do
    begin
      if Xubes[i].X = 127 then continue;

      if (CubesArray[Xubes[i].X + Xubes[i].Xinc, Xubes[i].Y + Xubes[i].Yinc] <> 8) or
         (Xubes[i].X + Xubes[i].Xinc < 0) or
         (Xubes[i].X + Xubes[i].Xinc > 19) or
         (Xubes[i].Y + Xubes[i].Yinc < 0) or
         (Xubes[i].Y + Xubes[i].Yinc > 13) then
      begin
        Xubes[i].Xinc:= 0;
        Xubes[i].Yinc:= 0;
        if ((Xubes[i].X - 1) >= 0) and (CubesArray[Xubes[i].X-1, Xubes[i].Y] = 8) then Xubes[i].Xinc:= -1 else
        if ((Xubes[i].X + 1) <= 19) and (CubesArray[Xubes[i].X+1, Xubes[i].Y] = 8) then Xubes[i].Xinc:= 1 else
        if ((Xubes[i].Y - 1) >= 0) and (CubesArray[Xubes[i].X, Xubes[i].Y-1] = 8) then Xubes[i].Yinc:= -1 else
        if ((Xubes[i].Y + 1) <= 13) and (CubesArray[Xubes[i].X, Xubes[i].Y+1] = 8) then Xubes[i].Yinc:= 1 else
        Xubes[i].X:= 127;
      end;
      Xubes[i].X:= Xubes[i].X + Xubes[i].Xinc;
      Xubes[i].Y:= Xubes[i].Y + Xubes[i].Yinc;
      CubesArray[Xubes[i].X, Xubes[i].Y]:= 7;
    end;

    for i:= 0 to 19 do
    for j:= 0 to 13 do
    if (CubesArray[i, j] > 0) and (CubesArray[i, j] < 8) then CubesArray[i, j]:= CubesArray[i, j] - 1;

    sVorhang.Play(0, 0, 0);

    If framer >= 75 then
    begin
      if player.Lives = 255 then
      begin
        player.Lives:= 3;
        SMode:= smLogo;
        FadeI:= true;
        LMode:= lmFade;
        logoy:= LOGO_Y_START;
      end else
      cubesClose;
    end;
  end;
end;

//=============================================================================
//  
//=============================================================================
procedure Render();
var
  i, j : Integer;
  x, y : Integer;
  hRet : HRESULT;
  rect : TRect;
begin
  if sMode = smCoder then
  begin
    Core_Graphic_Clear(0, 0, 0);

    Core_Graphic_DrawSprite(80, 0, coderpro, nil);

    DrawString('Turrican Game by Darthman', 64, 170);
    DrawString('Developed in borland delphi', 56, 180);
    DrawString('for independent programmer contest', 24, 190);
  end;

  if sMode = smLogo then
  begin
    Core_Graphic_Clear(0, 0, 0);

    Core_Graphic_DrawSprite(0, logoy, logo, nil);

    if LMode = lmstay then
    begin

    for i:=0 to 4 do
    begin
      SetRect(rect, stars[i].Frame*15, 0, stars[i].Frame*15+15, 15);
      Core_Graphic_DrawSprite(stars[i].X, stars[i].Y, star, @rect);
    end;

    for i:=1 to 5 do
    for j:=0 to logoLevel.tilescount-1 do
    if logoLevel.tiles[j].layer = i then
    begin
      x:= (logoLevel.tiles[j].No mod 10)*32;
      y:= (logoLevel.tiles[j].No div 10)*32;
      SetRect(rect, x, y, x+32, y+32);
      Core_Graphic_DrawSprite(logoLevel.tiles[j].X*32, logoLevel.tiles[j].Y*32 + 32, Tiles, @rect);
    end;

    if (framer mod 30) < 15 then
    DrawString('Press Fire To Start', 80, 100);

   { DrawString('So you think you know about the hidden', 5, 120);
    DrawString('secrets & treasures, you know about the', 5, 130);
    DrawString('7 mega-weapons, like flame thrower,', 5, 140);
    DrawString('you know how TURRICAN moves and looks', 5, 150);
    DrawString('like, you know about the huge mazes', 5, 160);
    DrawString('and 5 different worlds spread over', 5, 170);
    DrawString('1500 screens,so what don''t you know? ...', 5, 180);
    DrawString('YOU AIN''T SEEN NOTHING YET!', 5, 190);   }
    end;
  end; // LM = lmstay 

  if sMode = smGame then
  begin
    Core_Graphic_Clear(150, 100, 255);

    for i:=1 to 5 do
    for j:=0 to level1.tilescount-1 do
    if Level1.tiles[j].layer = i then
    begin
      x:= (Level1.tiles[j].No mod 10)*32;
      y:= (Level1.tiles[j].No div 10)*32;
      SetRect(rect, x, y, x+32, y+32);
      Core_Graphic_DrawSprite(Level1.tiles[j].X*32 + Xpos, Level1.tiles[j].Y*32 + Ypos, Tiles, @rect);
    end;

    if Level1.CrystalsCount > 0 then
    for j:=0 to level1.CrystalsCount-1 do
    Core_Graphic_DrawSprite(Level1.crystals[j].X + Xpos, Level1.crystals[j].Y + Ypos, crystal, nil);

    Player.Draw;

    EnemyEngine.Draw(Xpos, Ypos);


    Core_Graphic_DrawSprite(16, 16, lives, nil);
    DrawDigits(player.Lives, 48, 16, 2);

    Core_Graphic_DrawSprite(0, 217, bar, nil);

    DrawString(IntToStr(player.Time), 111, 226);
    DrawString(IntToStr(player.Collected), 166, 226);
    DrawString('00', 215, 226);

    Core_Graphic_DrawSprite(220, 8, score, nil);
    DrawDigits(player.Score, 230, 16, 8);

    SetRect(rect, 239, 226, 239+trunc((73 / MAX_ENERGY) * player.Energy), 226+6);
    Core_Graphic_Fill(0, 255, 100, @rect);

    if (GMode = gmCubesOpen) or (GMode = gmCubesClose) then
    begin
      for i:=0 to 19 do
      for j:=0 to 13 do
      begin
        if cubesarray[i, j] <> 255 then SetRect(rect, cubesarray[i,j]*16, 0, cubesarray[i,j]*16 + 16, 16)
                                   else SetRect(rect, 0, 0, 16, 16);
        if (cubesarray[i, j] = 255) or (cubesarray[i, j] < 8) then Core_Graphic_DrawSprite(i*16, j*16 - 7, Cubes, @rect);
      end;
    end;
  end;

  if FadeO then Core_Graphic_FadeOut;
  if FadeI then Core_Graphic_FadeIn;

  while True do begin
    hRet := DDSPrimary.Flip(nil, DDFLIP_WAIT);
    if hRet = DDERR_SURFACELOST then begin
       if Failed (RestoreAll) then Exit;
    end
    else Break;
  end;
end;

//=============================================================================
//    Directdraw
//=============================================================================
function RestoreAll : HRESULT;
var
  hRet : HRESULT;
begin
  hRet := DDSPrimary._Restore;
  if Succeeded (hRet) then begin
      hRet := DDSSecondary._Restore;
      if Failed (hRet) then begin
         Result := hRet;
         Exit;
      end;
      hRet := DDReLoadBitmap(Tiles, 'data/tiles.bmp');
      if Failed (hRet) then MessageBox(h_Wnd, '', 'DDReLoadBitmap', MB_ICONERROR);
      hRet := Tiles._Restore;
      if Failed (hRet) then begin
         Result := hRet;
         Exit;
      end;
      Result := DDReLoadBitmap(coderpro, 'data/coderpro.bmp');
      coderpro._Restore;
      Result := DDReLoadBitmap(logo, 'data/logo.bmp');
      logo._Restore;
      Result := DDReLoadBitmap(star, 'data/star.bmp');
      star._Restore;
      Result := DDReLoadBitmap(font, 'data/font.bmp');
      font._Restore;
      Result := DDReLoadBitmap(digits, 'data/digits.bmp');
      digits._Restore;
      Result := DDReLoadBitmap(bar, 'data/bar.bmp');
      bar._Restore;
      Result := DDReLoadBitmap(lives, 'data/lives.bmp');
      lives._Restore;
      Result := DDReLoadBitmap(score, 'data/score.bmp');
      score._Restore;
      Result := DDReLoadBitmap(crystal, 'data/crystal.bmp');
      crystal._Restore;
      Result := DDReLoadBitmap(Cubes, 'data/cubes.bmp');
      Cubes._Restore;
      Result := DDReLoadBitmap(bonusflyer, 'data/bonusflyer.bmp');
      bonusflyer._Restore;
      Result := DDReLoadBitmap(Bonuses, 'data/powerup.bmp');
      Bonuses._Restore;
      Result := DDReLoadBitmap(BOSS, 'data/boss.bmp');
      BOSS._Restore;
      Result := DDReLoadBitmap(dronebomb, 'data/drone_bomb.bmp');
      dronebomb._Restore;

      Result:= Player.restoreall;

      weapon_laser.restore;
  end else Result := hRet;
end;

//=============================================================================
//   
//=============================================================================
procedure CubesClose();
var
 i, j : integer;
begin
  GMode:= gmCubesClose;

  player.process;

  for i:=0 to 19 do
  for j:=0 to 13 do
  CubesArray[i, j]:= 255;

  Xubes[0].X:= 9;
  Xubes[0].Y:= 7;
  Xubes[0].Xinc:= 0;
  Xubes[0].Yinc:= -1;

  Xubes[1].X:= 10;
  Xubes[1].Y:= 7;
  Xubes[1].Xinc:= 0;
  Xubes[1].Yinc:= -1;

  Xubes[2].X:= 9;
  Xubes[2].Y:= 6;
  Xubes[2].Xinc:= 0;
  Xubes[2].Yinc:= 1;

  Xubes[3].X:= 10;
  Xubes[3].Y:= 6;
  Xubes[3].Xinc:= 0;
  Xubes[3].Yinc:= 1;

  framer:= 0;
end;

//=============================================================================
//   
//=============================================================================
procedure CubesOpen();
var
 i, j : integer;
begin
  GMode:= gmCubesOpen;

  for i:=0 to 19 do
  for j:=0 to 13 do
  CubesArray[i, j]:= 8;

  Xubes[0].X:= 9;
  Xubes[0].Y:= 7;
  Xubes[0].Xinc:= 0;
  Xubes[0].Yinc:= -1;

  Xubes[1].X:= 10;
  Xubes[1].Y:= 7;
  Xubes[1].Xinc:= 0;
  Xubes[1].Yinc:= -1;

  Xubes[2].X:= 9;
  Xubes[2].Y:= 6;
  Xubes[2].Xinc:= 0;
  Xubes[2].Yinc:= 1;

  Xubes[3].X:= 10;
  Xubes[3].Y:= 6;
  Xubes[3].Xinc:= 0;
  Xubes[3].Yinc:= 1;

  framer:= 0;
end;

//=============================================================================
//     
//=============================================================================
procedure ReadKeyBoard();
var
  hret : HRESULT;
  diks : Array [0..255] of BYTE;
  movex, movey : Integer;
  js : TDIJoyState2;
begin
  if pause > 0 then exit;

  // joy
  if DIJ <> nil then
  begin
    hret:= DIJ.Poll;
    hret:= DIJ.GetDeviceState(SizeOf(TDIJoyState2), @js);
    if Failed (hRet) then DIJ.Acquire;
  end else
  begin
    js.lX:= 32000;
    js.lY:= 32000;
  end;

  // key
  ZeroMemory(@diks, SizeOf(diks));
  hRet := DIK.GetDeviceState(SizeOf(diks), @diks);
  if Failed (hRet) then begin
     hRet := DIK.Acquire;
     while hRet = DIERR_INPUTLOST do
           hRet := DIK.Acquire;
  end;

  if diks [DIK_ESCAPE] and $80 <> 0 then
  begin
    Finished:= true;
    Exit;
  end;

///////////////////

  if (sMode = smLogo) and ((diks [DIK_SPACE] and $80 <> 0) or (js.rgbButtons[0] and $80 <> 0)) then
  begin
    sMode:= smGame;

    EndMusic;
    StartMusic('mdat.world_1');
    CubesClose;

    Exit;
  end;

  if SMode <> smGame then exit;
  if GMode <> gmGame then exit;

  movex:= 0;
  movey:= 0;

  if (diks [DIK_RIGHT] and $80 <> 0) or (js.lX > 40000) then   //32000 - idle mode, 64000 max, 0 min
  movex:= 1;

  if (diks [DIK_LEFT] and $80 <> 0) or (js.lX < 26000) then
  movex:= -1;

  if (diks [DIK_UP] and $80 <> 0) or (js.lY < 26000) then
  movey:= -1;

  if (diks [DIK_DOWN] and $80 <> 0) or (js.lY > 40000) then
  movey:= 1;

  player.move(MoveX, MoveY);

  if (diks [DIK_LCONTROL] and $80 <> 0) or (js.rgbButtons[0] and $80 <> 0) then    //$80 = 128. 128 is pressed key
  player.Fire;
end;

//=============================================================================
//       .
//=============================================================================
function Collide(var floor: Boolean; var X, Y : integer; movex, movey : Integer) : boolean;
begin
  result:= false;
  floor:= false;

  //     , 
  //  ,   
  //    :)    ""
  //    

// left
    if movex < 0 then
    begin
      if Level1.grid[(X+4) div 32, (Y+8) div 32] then
      begin
        if (Y - Y div 32 + 32) > 8 then
        X:= ((X+32) div 32) * 32 - 4;
      end;
    end;

// right
    if movex > 0 then
    begin
      if Level1.grid[(X-4) div 32 + 1, (Y+8) div 32] then
      begin
        if (Y - Y div 32 + 32) > 8 then
        X:= ((X) div 32) * 32 + 4;
      end;
    end;

// bottom
    if movey < 0 then
    begin
      if Level1.grid[(X+4) div 32, (Y) div 32] then
      begin
        Y:= ((Y) div 32) * 32 + 32;
        Result:= true;
      end else
      if Level1.grid[(X-4) div 32 + 1, (Y) div 32] then
      if ((X mod 32) > 8) then
      begin
        Y:= ((Y) div 32) * 32 + 32;
        Result:= true;
      end;
    end;

  // top
    if movey > 0 then
    begin
      if Level1.grid[(X+4) div 32, (Y + 32) div 32] then
      begin
        if (-Y + ((Y) div 32) * 32) < 6 then
        Y:= ((Y) div 32) * 32;
        if (-Y + ((Y) div 32) * 32) < 6 then
        floor:= true;
      end else
      if (X mod 32) > 8 then
      if (-Y + ((Y) div 32) * 32) < 6 then
      if Level1.grid[(X-4) div 32 + 1, (Y + 32) div 32] then
      begin
        Y:= ((Y) div 32) * 32;
        floor:= true;
      end;
    end;
end;

end.
