unit turrican;

interface

uses
  Windows,
  Directdraw,
  DDUtil,
  Weaponry,
  Core_Graphic,
  Core_sound;

const
  MAX_JUMP_TIME = 12;      //    
  MAX_GAME_TIME = 499;     //     1 
  MAX_ENERGY = 100;        //  

  TURR_WIDTH = 32;         // "" 
  TURR_HEIGHT = 35;        // "" 

type
  TState = (sFire, sStand, sFly, sSurround, sSit, sRoll, sDie, sRespawn, sMove);   //  

  //  
  TTurrican = class
  private
    YInc : Integer;
    Anim : Integer;
    JumpTime : Integer;
    onGround : Boolean;
    movex, movey : integer;
    Ffire : Boolean;
    Ffiretime : integer;
    turrican_fire_east,
    turrican_fire_west,
    turrican_jump_east,
    turrican_jump_west,
    turrican_stand_east,
    turrican_stand_west,
    turrican_sit_east,
    turrican_sit_west,
    turrican_walk_east,
    turrican_walk_west : IDirectDrawSurface7;
    Fstate : TState;
    FDir : Shortint;
    Ftime : Word;
    FrespX, FrespY : Word;
  public
    X, Y : Integer;
    Time : Word;
    Collected : Word;
    Score : Cardinal;
    Lives : Byte;
    Weapon : Tweapon;
    Energy : Integer;
    constructor create(sX, sY : Word);
    procedure loadsprites;
    function RestoreAll : hresult;
    procedure Move(i, j : integer);
    procedure draw();
    procedure process();
    procedure Fire();
    procedure Collect();
    procedure Respawn(XX, YY : integer);
    procedure Death();
  end;

implementation

uses defs, mainengine;

//=============================================================================
//   .  .
//=============================================================================
constructor TTurrican.create(sX, sY : Word);
begin
  inherited create;

  Ffire:= false;

  Collected:= 0;
  Score:= 0;
  Lives:= 3;

  movex:= 0;
  movey:= 0;

  Fstate:= sStand;
  FDir:= 1;

  X:= sX;
  Y:= sY;
  FrespX:= sX;
  FrespY:= sY;

  onGround:= true;
  Move(0, 0);
  JumpTime:= MAX_JUMP_TIME;
  Time:= MAX_GAME_TIME;
  Ftime:= 0;
  Energy:= MAX_ENERGY;
end;

//=============================================================================
//   -   :) ...
//=============================================================================
procedure TTurrican.Collect();
begin
  player.Collected:= player.Collected + 1;
  player.Score:= player.Score + 10;
  if player.Collected = 100 then
  begin
    player.Collected:= 0;
    player.Lives:= player.Lives + 1;
    Core_Sound_Play(sExtraLive);
  end;
  Core_Sound_Play(sDiamond);
end;

              
//=============================================================================
//  .      1    
//       .
//=============================================================================
procedure TTurrican.loadsprites;
begin
  Core_Graphic_LoadImage('data/turrican_fire_east.bmp', turrican_fire_east, $FF00FF);
  Core_Graphic_LoadImage('data/turrican_fire_west.bmp', turrican_fire_west, $FF00FF);
  Core_Graphic_LoadImage('data/turrican_jump_east.bmp', turrican_jump_east, $FF00FF);
  Core_Graphic_LoadImage('data/turrican_jump_west.bmp', turrican_jump_west, $FF00FF);
  Core_Graphic_LoadImage('data/turrican_stand_east.bmp', turrican_stand_east, $FF00FF);
  Core_Graphic_LoadImage('data/turrican_stand_west.bmp', turrican_stand_west, $FF00FF);
  Core_Graphic_LoadImage('data/turrican_sit_east.bmp', turrican_sit_east, $FF00FF);
  Core_Graphic_LoadImage('data/turrican_sit_west.bmp', turrican_sit_west, $FF00FF);
  Core_Graphic_LoadImage('data/turrican_walk_east.bmp', turrican_walk_east, $FF00FF);
  Core_Graphic_LoadImage('data/turrican_walk_west.bmp', turrican_walk_west, $FF00FF);
end;

//=============================================================================
//  .
//=============================================================================
function TTurrican.RestoreAll : hresult;
begin
  Result := DDReLoadBitmap(turrican_fire_east, 'data/turrican_fire_east.bmp');
  turrican_fire_east._Restore;

  Result := DDReLoadBitmap(turrican_fire_west, 'data/turrican_fire_west.bmp');
  turrican_fire_west._Restore;

  Result := DDReLoadBitmap(turrican_jump_east, 'data/turrican_jump_east.bmp');
  turrican_jump_east._Restore;

  Result := DDReLoadBitmap(turrican_jump_west, 'data/turrican_jump_west.bmp');
  turrican_jump_west._Restore;

  Result := DDReLoadBitmap(turrican_stand_east, 'data/turrican_stand_east.bmp');
  turrican_stand_east._Restore;

  Result := DDReLoadBitmap(turrican_stand_west, 'data/turrican_stand_west.bmp');
  turrican_stand_west._Restore;

  Result := DDReLoadBitmap(turrican_sit_east, 'data/turrican_sit_east.bmp');
  turrican_sit_east._Restore;

  Result := DDReLoadBitmap(turrican_sit_west, 'data/turrican_sit_west.bmp');
  turrican_sit_west._Restore;

 { Result := DDReLoadBitmap(turrican_surround, 'data/turrican_surround.bmp');
  turrican_surround._Restore;
 }
  Result := DDReLoadBitmap(turrican_walk_east, 'data/turrican_walk_east.bmp');
  turrican_walk_east._Restore;

  Result := DDReLoadBitmap(turrican_walk_west, 'data/turrican_walk_west.bmp');
  turrican_walk_west._Restore;
end;

//=============================================================================
//  , ,  .  ,
//       .
//=============================================================================
procedure TTurrican.process();
var
  groundtemp : Boolean;
begin
  if (Energy <= 0) or (Time = 0) then
  begin
    player.Death;
    exit;
  end;

  Y:= Y - Yinc;
  movey:= movey-Yinc;
  if (YInc > -14) then Dec(Yinc);
  Dec(JumpTime);

  groundtemp:= onGround;
  if Collide(onground, X, Y, movex, movey) then
  begin
    Yinc:= 0;
    JumpTime:= 0;
  end;

  if onGround then
  begin
    JumpTime:= MAX_JUMP_TIME;
    if groundtemp = false then Core_Sound_Play(sLanding);
  end else
  begin
    Fstate:= sFly;
    if groundtemp then YInc:= 0;
  end;

  movex:= 0;
  movey:= 0;

  //    
  Xpos:= -X + screenx div 2;
  Ypos:= -Y + screeny div 2 + 1;

  if Xpos > 0 then Xpos:= 0;
  if Ypos > 0 then Ypos:= 0;  

  Ffiretime:= Ffiretime - 1;
  if Ffiretime < 0 then Ffiretime:= 0;

  inc(Ftime);
  if Ftime = 33 then
  begin
    Ftime:= 0;
    Dec(Time);
  end;
end;

//=============================================================================
//    .
//=============================================================================
procedure TTurrican.draw();
var
  sX, sY : Integer;
  rect : TRect;
begin
  sX:= X + Xpos;
  sY:= Y + Ypos;

  if Fstate = sSit then
  begin
    if FDir = -1 then Core_Graphic_DrawSprite(sX, sY+10, player.turrican_sit_west, nil)
                 else Core_Graphic_DrawSprite(sX, sY+10, player.turrican_sit_east, nil);

    if Ffire then
    if FDir = -1 then Core_Graphic_DrawSprite(sX-15, sY+15, player.turrican_fire_west, nil)
                 else Core_Graphic_DrawSprite(sX+30, sY+15, player.turrican_fire_east, nil);
  end else
  begin
    if Fstate = sFly then
    begin
      SetRect(rect, 0, 0, 29, 41);
      if FDir = -1 then Core_Graphic_DrawSprite(sX, sY, player.turrican_jump_west, @rect)
                   else Core_Graphic_DrawSprite(sX, sY, player.turrican_jump_east, @rect);
    end;

    if Fstate = sStand then
    if FDir = -1 then Core_Graphic_DrawSprite(sX, sY, player.turrican_stand_west, nil)
                 else Core_Graphic_DrawSprite(sX, sY, player.turrican_stand_east, nil);

    if Fstate = sMove then
    begin
      SetRect(rect, anim*32, 0, anim*32 + 32, 37);
      if FDir = -1 then Core_Graphic_DrawSprite(sX, sY, player.turrican_walk_west, @rect)
                   else Core_Graphic_DrawSprite(sX, sY, player.turrican_walk_east, @rect);
    end;

    if Ffire then
    if FDir = -1 then Core_Graphic_DrawSprite(sX-13, sY+5, player.turrican_fire_west, nil)
                 else Core_Graphic_DrawSprite(sX+28, sY+5, player.turrican_fire_east, nil);

    end;
    
  Ffire:= false;

  Weapon.Draw;
end;

//=============================================================================
//        (
//   )
//=============================================================================
procedure TTurrican.Move(i, j : integer);
begin
  if i = -1 then
  begin
    FDir:= -1;
    if (X-3) <= 0 then exit;
    if Fstate <> sSit then begin X:= X-3; movex:= movex - 3; end;
    if onGround then Fstate:= sMove;
  end;

  if i = 1 then
  begin
    FDir:= 1;
    if Fstate<> sSit then begin X:= X+3; movex:= movex + 3; end;
    if onGround then Fstate:= sMove;
  end;

  if j = -1 then
  if JumpTime > 0 then
  begin
    Yinc:= 7;
    Fstate:= sFly;
    onGround:= false;
  end;

  if j = 1 then
  begin
    if onGround then Fstate:= sSit;
  end;


  if (i=0) and (j=0) and onGround then Fstate:= sStand;
  Anim:= anim + 1;
  if Anim > 13 then Anim:= 0;
end;

//=============================================================================
// .       .
//=============================================================================
procedure TTurrican.Fire();
begin
  if Ffiretime = 0 then
  begin
    Ffire:= true;
    Ffiretime:= 8;


    if Fstate = sSit then
    if fdir = -1 then Weapon.Shoot(X+10,  Y + 21, fdir)
                 else Weapon.Shoot(X + 15, Y + 21, fdir)
                     else
    if fdir = -1 then Weapon.Shoot(X+10, Y + 12, fdir)
                 else Weapon.Shoot(X + 15, Y + 12, fdir);
  end;
end;

//=============================================================================
// respawn 
//=============================================================================
procedure TTurrican.Respawn(XX, YY : integer);
begin
  FrespX:= XX;
  FrespY:= YY;

  X:= FrespX;
  Y:= FrespY;

  Ffire:= false;

  movex:= 0;
  movey:= 0;

  Fstate:= sFly;
  FDir:= 1;

  onGround:= false;
  Move(0, 0);
  JumpTime:= MAX_JUMP_TIME;
  Time:= MAX_GAME_TIME;
  Ftime:= 0;
  Energy:= MAX_ENERGY;

  CubesOpen;
end;

//=============================================================================
//  
//=============================================================================
procedure TTurrican.Death();
begin
  Lives:= Lives - 1;
  if Weapon.Level > 0 then Weapon.Level:= Weapon.Level - 1;

  respawn(FrespX, FrespY);
end;


end.
